/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.gebietsbaum.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class GebietUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String nummer;

    public java.lang.String getNummer(){
      return nummer;
    }

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietsartUK gebietsartUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietsartUK getGebietsartUK(){
      return gebietsartUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK;

    public de.ivu.elect.business.wahl.entity.WahlterminUK getWahlterminUK(){
      return wahlterminUK;
    }

  public GebietUK(
java.lang.String nummer
,   de.ivu.elect.business.gebietsbaum.entity.GebietsartUK gebietsartUK
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
,   de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK
  ) {
    super();


      this.nummer = nummer;
        this.gebietsartUK = gebietsartUK;
      this.wahlUK = wahlUK;
      this.wahlterminUK = wahlterminUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((nummer == null) ? 0 : nummer.hashCode());
        
                    result = result + ((gebietsartUK == null) ? 0 : gebietsartUK.hashCode());
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
                    result = result + ((wahlterminUK == null) ? 0 : wahlterminUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            GebietUK other = (GebietUK) obj;

                if (nummer == null) {
          if (other.nummer != null) {
            return false;
          }
        } else if (!nummer.equals(other.nummer)) {
          return false;
        }
        
                if (gebietsartUK == null) {
          if (other.gebietsartUK != null) {
            return false;
          }
        } else if (!gebietsartUK.equals(other.gebietsartUK)) {
          return false;
        }
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
                if (wahlterminUK == null) {
          if (other.wahlterminUK != null) {
            return false;
          }
        } else if (!wahlterminUK.equals(other.wahlterminUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return GebietConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietsartUK.getAllEntityFieldValues());
    result.addAll(wahlUK.getAllEntityFieldValues());
    result.addAll(wahlterminUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(GebietConstants.MESSAGE_KEY_ENTITY_EINZAHL, GebietConstants.MESSAGE_KEY_NUMMER_EINZAHL, nummer));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "GebietUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"nummer="+nummer
                                        +", "                +"gebietsartUK="+gebietsartUK
                            +", "                +"wahlUK="+wahlUK
                            +", "                +"wahlterminUK="+wahlterminUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(nummer);
     return list;
   }

            public static <E extends Gebiet> java.util.Map<GebietUK, E> mappeGebietNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Gebiet::getGebietUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Gebiet, GebietUK> getGebietToUKFunction() {
                return Gebiet::getGebietUK;
                }

}
